/*
 * Arrebol Consultancy copyright.
 * 
 * This code belongs to Arrebol Consultancy
 * its use, redistribution or modification are prohibited 
 * without written authorization from Arrebol Consultancy.
 */
package com.arrebol.apc.model.views;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import org.hibernate.annotations.Immutable;

/**
 *
 * @author Oscar Armando Vargas Cardenas <oscar.vargas@arrebol.com.mx>
 */
@Entity
@Immutable
@Table(name = "APC_ADVANCE_USER_DAILY_DETAIL_VIEW")
public class AdvanceUserDailyDetail implements Serializable{

    private static final long serialVersionUID = -4849944622024557288L;
    
    @Id
    @Column(name = "id", length = 36)
    private String id;
    
    @Column(name = "id_user")
    private String idUser;
    
    @Column(name = "customer_name")
    private String customerName;
    
    @Column(name = "payment_amount")
    private String paymentAmount;
    
    @Column(name = "created_on")
    private Date createdOn;
    
    @Column(name = "address_business")
    private String address;
    
    @Column(name = "type_ayment")
    private String typePayment;
    
    @Column(name = "amount_paid")
    private String amountPaid;
    
    @Column(name = "amount_to_pay")
    private String amountToPay;
    
    @Column(name = "last_reference_number")
    private String lastReference;
    
    @Column(name = "loan_status")
    private String loanStatus;
    
    @Column(name = "num_fee")
    private String numFee;
    
    @Column(name = "saldo_insoluto")
    private String saldoInsoluto;
    
    @Column(name = "amount_loan")
    private String amountLoan;
    

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getIdUser() {
        return idUser;
    }

    public void setIdUser(String idUser) {
        this.idUser = idUser;
    }

    public String getCustomerName() {
        return customerName;
    }

    public void setCustomerName(String customerName) {
        this.customerName = customerName;
    }

    public String getPaymentAmount() {
        return paymentAmount;
    }

    public void setPaymentAmount(String paymentAmount) {
        this.paymentAmount = paymentAmount;
    }

    public Date getCreatedOn() {
        return createdOn;
    }

    public void setCreatedOn(Date createdOn) {
        this.createdOn = createdOn;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getTypePayment() {
        return typePayment;
    }

    public void setTypePayment(String typePayment) {
        this.typePayment = typePayment;
    }

    public String getAmountPaid() {
        return amountPaid;
    }

    public void setAmountPaid(String amountPaid) {
        this.amountPaid = amountPaid;
    }

    public String getAmountToPay() {
        return amountToPay;
    }

    public void setAmountToPay(String amountToPay) {
        this.amountToPay = amountToPay;
    }

    public String getLastReference() {
        return lastReference;
    }

    public void setLastReference(String lastReference) {
        this.lastReference = lastReference;
    }

    public String getLoanStatus() {
        return loanStatus;
    }

    public void setLoanStatus(String loanStatus) {
        this.loanStatus = loanStatus;
    }

    public String getNumFee() {
        return numFee;
    }

    public void setNumFee(String numFee) {
        this.numFee = numFee;
    }

    public String getSaldoInsoluto() {
        return saldoInsoluto;
    }

    public void setSaldoInsoluto(String saldoInsoluto) {
        this.saldoInsoluto = saldoInsoluto;
    }

    public String getAmountLoan() {
        return amountLoan;
    }

    public void setAmountLoan(String amountLoan) {
        this.amountLoan = amountLoan;
    }
   
    
    
    
}
