/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.arrebol.apc.model.views;

import com.arrebol.apc.model.enums.FeeStatus;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import org.hibernate.annotations.GenericGenerator;

/**
 *
 * @author David Rodriguez
 */
@Entity
@Table(name = "APC_FEES_VIEW")
public class FeesView implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(generator = "uuid")
    @GenericGenerator(name = "uuid", strategy = "uuid2")
    @Column(name = "id", length = 36)
    private String id;

    @Column(name = "id_user", length = 36)
    private String idUser;

    @Column(name = "name")
    private String userName;
    
    @Column(name = "id_route", length = 36)
    private String idRoute;

    @Column(name = "route_name")
    private String routeName;

    @Column(name = "total_fees")
    private BigDecimal totalFees;
    
    @Enumerated(EnumType.STRING)
    @Column(name = "fee_status")
    FeeStatus feeStatus;

    @Column(name = "created_on")
    private Date createdOn;
    
    @Column(name = "total_fee_paid")
    private BigDecimal totalFeePaid;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public Date getCreatedOn() {
        return createdOn;
    }

    public void setCreatedOn(Date createdOn) {
        this.createdOn = createdOn;
    }

    public String getIdUser() {
        return idUser;
    }

    public void setIdUser(String idUser) {
        this.idUser = idUser;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public BigDecimal getTotalFees() {
        return totalFees;
    }

    public void setTotalFees(BigDecimal totalFees) {
        this.totalFees = totalFees;
    }
    public String getIdRoute() {
        return idRoute;
    }

    public void setIdRoute(String idRoute) {
        this.idRoute = idRoute;
    }

    public String getRouteName() {
        return routeName;
    }

    public void setRouteName(String routeName) {
        this.routeName = routeName;
    }

    public FeeStatus getFeeStatus() {
        return feeStatus;
    }

    public void setFeeStatus(FeeStatus feeStatus) {
        this.feeStatus = feeStatus;
    }
    
    public BigDecimal getTotalFeePaid() {
        return totalFeePaid;
    }

    public void setTotalFeePaid(BigDecimal totalFeePaid) {
        this.totalFeePaid = totalFeePaid;
    }
    
    @Override
    public String toString() {
        return "FeesView{" + "idUser=" + idUser + ", userName=" + userName + ", totalFees=" + totalFees + ", createdOn=" + createdOn + '}';
    }
}
